=== debian/changelog ===
vectorscan (5.4.11-2ubuntu1) oracular; urgency=medium

  * d/rules: disable LTO flags to fix linking issues on Ubuntu (LP: #2071664).

 -- Zixing Liu <zixing.liu@canonical.com>  Wed, 19 Jun 2024 13:04:15 -0600

vectorscan (5.4.11-2) unstable; urgency=medium

  * Make build reproducible: Closes: #1056649
    Thanks to Chris Lamb <lamby@debian.org> for the patch
  * Set ppc64le target arch to power8, as that's the port's default. Caused
    a SIGILL on Debian's CI:
    https://ci.debian.net/packages/v/vectorscan/testing/ppc64el/41889410/

 -- Konstantinos Margaritis <markos@debian.org>  Sat, 20 Jan 2024 23:26:19 +0200

vectorscan (5.4.11-1) unstable; urgency=medium

  * New upstream release

 -- Konstantinos Margaritis <markos@debian.org>  Mon, 20 Nov 2023 14:19:40 +0200

vectorscan (5.4.10.1-1) unstable; urgency=medium

  * New upstream release.
  * Enable FAT_RUNTIME=on for arm64.

 -- Konstantinos Margaritis <markos@debian.org>  Fri, 08 Sep 2023 16:46:44 +0300
