=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto

ifeq ($(DEB_HOST_ARCH),amd64)
export DEB_CMAKE_FLAGS = -DBUILD_AVX2=on -DBUILD_AVX512=on -DBUILD_AVX512VBMI=off -DFAT_RUNTIME=on
endif

ifeq ($(DEB_HOST_ARCH),arm64)
export DEB_CMAKE_FLAGS = -DBUILD_SVE=on -DBUILD_SVE2=on -DBUILD_SVE2_BITPERM=on -DFAT_RUNTIME=on
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_STATIC_LIBS=On -DBUILD_SHARED_LIBS=On \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		${DEB_CMAKE_FLAGS}
